<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070629;13393200">
	<META NAME="CHANGED" CONTENT="20070710;12544200">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Convert CFG to PDA (LL)</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#definition"><U>Definition</U></A><U><BR></U><A HREF="#how to"><U>How
to Convert CFG to PDA (LL)</U></A></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition</H2>
<P STYLE="margin-bottom: 0in">We will convert a CFG to a PDA using
the LL parsing method.</P>
<P STYLE="margin-bottom: 0in">The idea behind the conversion from a
CFG to an equivalent PDA (NPDA in this case) is to derive the
productions through the stack. The conversion starts by pushing the
start variable on the stack. Whenever there is a variable on the top
of the stack, the conversion replaces the variable by its right side,
thus applying a production toward deriving the string. Whenever a
terminal is on top of the stack and the same symbol is the current
input symbol, then the conversion pops the terminal off the stack and
processes it as an input symbol. If the stack is emptied, then all
the variables were replaced and all the terminals matched, so the
string is accepted.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A>How
to Convert CFG to PDA (LL)</H2>
<P><A NAME="language1"></A>We will begin by loading the same grammar
that we used for building the LL(1) parse table. You can view that
grammar rule in <B>Build LL(1) Parse Table</B> tutorial. (or you can
download the file, <A HREF="grammarToLL.jff">grammarToLL.jff</A>).
After loading the grammar, click on <B>Convert </B>and click <B>Convert
CFG to PDA (LL)</B>. Now, your JFLAP window should look like this : 
</P>
<P ALIGN=CENTER><A NAME="editor"></A><IMG SRC="images/toPDA.png" NAME="Graphic1" ALIGN=MIDDLE WIDTH=629 HEIGHT=504 BORDER=0></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P STYLE="margin-bottom: 0in">We need to add transitions between the
states. Our goal is to reach state q2. We have already added the
“popped off” loop transitions for matching terminals(the loops on
state q1). We must now add the “pushed on” loop transitions on
state q1 for each production to get the terminals on the stack. For
each production, the left side of the production is popped and the
right side of the production is pushed. In this case, we can add the
transition from q1 to q1 using “lambda, S : aABb”. This addition
successfully portrays our production “S-&gt;aABb”. 
</P>
<P STYLE="margin-bottom: 0in"><B>*NOTE </B>: You can click on the
production on the left side and click on <B>Create Selected</B> to
add the corresponding transition in the PDA.</P>
<P STYLE="margin-bottom: 0in">After entering all the transitions to
the PDA, your JFLAP window should look similar to this : 
</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_1.png" NAME="Graphic2" ALIGN=MIDDLE WIDTH=629 HEIGHT=504 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">Now, we
have successfully transformed the context-free grammar to a pushdown
automaton. We can export this PDA and test it on some inputs to see
if the converted PDA accepts the same string as our original CFG.
After exporting the PDA, your new JFLAP window should look like :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_2.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=687 HEIGHT=539 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now let's run multiple run
to test many strings. Click on <B>Input, </B>then click on <B>Multiple
Run</B>. In the <B>Multiple Run </B>window, type input “aa”,
“aaaccbcb”, “abbbba”, “accb”, “aaccb”, “acb”,
“bcb”. In the Grammar window that we have opened for the
conversion, click on <B>Input</B> then click on <B>Multiple Brute
Force Parse</B> and enter the same strings into the input columns.
After running the same inputs on PDA and Brute Force Parser, you
should get the result : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=687 HEIGHT=539 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_4.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=626 HEIGHT=507 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Notice that both the PDA and
our original grammar accepts/rejects the same strings. 
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on Converting CFG to PDA (LL). Thanks for reading!</B></P>
</BODY>
</HTML>